'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: b_upd_DatabaseTypes.inc,v $
'*
'*  $Revision: 1.12.2.1 $
'*
'*  last change: $Author: msc $ $Date: 2003/12/30 08:41:23 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**********************************************************************************
'*
'* owner : marc.schwanz@sun.com
'*
'* short description : DatabaseTypes routines for Base Update Test
'*
'************************************************************************
'*
' #1 tTabAdabasOne
' #1 tTabAdabasTwo
' #1 tTabODBC     
' #1 tTabJDBC     
' #1 tTabdBase
' #1 tTabADO
' #1 tTabTEXTBase
' #1 tTabSpreadsheet
'*
'\***********************************************************************************
Dim gCountOfTypes as integer

sub b_upd_DatabaseTypes

   printlog "------------------ b_upt_DatabaseTypes.inc ---------------------"   
   printlog "-------------------- Database Types ----------------------"
     
   if gPlatform <> "x86" then
     call tTabAdabasOne
     call tTabAdabasTwo
   end if
     call tTabODBC     
     call tTabJDBC     
     call tTabdBase
   if gPlatgroup = "w95" then
     call tTabADO
   end if
     call tTabTEXTBase
     call tTabSpreadsheet
     
end sub

'-------------------------------------------------------------------------

testcase tTabAdabasOne
 Dim ListCountA as integer
 dim i as integer
 dim sChar as string
 '/// Description ///'
 printlog "tab page Adabas"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  NewDatasource.Click	
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  DatabaseType.Select(2)
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabODBC
 Kontext "TabODBC"
  call Dialogtest(TabODBC)
  ListCountA = Adabas_CharacterSet.GetItemCount
  if ListCountA <> 53 then
    warnlog "There should be 53 character sets available but there are " & ListCountA & " sets available!?"
  end if  
  for i = 1 to ListCountA
        sChar = Adabas_CharacterSet.GetItemText(i)
        select case i
            case 1:
                if iSprache = 33 then                
                    TestChar("Système",sChar)
                elseif iSprache = 34 then
                    TestChar("Sistema",sChar)
                elseif iSprache = 39 then
                    TestChar("Sistema",sChar)
                elseif iSprache = 55 then
                    TestChar("Sistema",sChar)
                elseif ( iSprache = 81 OR iSprache = 82 OR iSprache = 86 OR iSprache = 88 ) then
                    'do nothing, because I can't compare CJK characters
                else
                    TestChar("System",sChar)
                endif
            case 2:            
                TestChar("(Windows-1252/WinLatin 1)",sChar) 
            case 3:    
                TestChar("(Apple Macintosh)",sChar) 
            case 4:   
                TestChar("(DOS/OS2-437/",sChar) 
            case 5:  
                TestChar("(DOS/OS2-850/",sChar) 
            case 6: 
                TestChar("(DOS/OS2-860/",sChar) 
            case 7:
                TestChar("(DOS/OS2-861/",sChar) 
            case 8:
                TestChar("(DOS/OS2-863/",sChar) 
            case 9:
                TestChar("(DOS/OS2-865/",sChar) 
            case 10:
                TestChar("(ASCII/",sChar) 
            case 11:
                TestChar("(ISO-8859-1)",sChar) 
            case 12:
                TestChar("(ISO-8859-2)",sChar) 
            case 13
                TestChar("(ISO-8859-3)",sChar) 
            case 14:
                TestChar("(ISO-8859-4)",sChar) 
            case 15:
                TestChar("(ISO-8859-5)",sChar) 
            case 16:
                TestChar("(ISO-8859-6)",sChar) 
            case 17:
                TestChar("(ISO-8859-7)",sChar) 
            case 18:
                TestChar("(ISO-8859-8)",sChar) 
            case 19:
                TestChar("(ISO-8859-9)",sChar) 
            case 20:
                TestChar("(ISO-8859-14)",sChar) 
            case 21:
                TestChar("(ISO-8859-15/",sChar) 
            case 22:
                TestChar("(DOS/OS2-852)",sChar) 
            case 23:
                TestChar("(DOS/OS2-862)",sChar) 
            case 24:
                TestChar("(DOS/OS2-864)",sChar) 
            case 25:
                TestChar("(DOS/OS2-866/",sChar) 
            case 26:
                TestChar("(Windows-874)",sChar) 
            case 27:
                TestChar("(Windows-1250/WinLatin 2)",sChar) 
            case 28:
                TestChar("(Windows-1251)",sChar) 
            case 29:
                TestChar("(Windows-1253)",sChar) 
            case 30:
                TestChar("(Windows-1254)",sChar) 
            case 31:
                TestChar("(Windows-1255)",sChar) 
            case 32:
                TestChar("(Windows-1256)",sChar) 
            case 33:
                TestChar("(Windows-1257)",sChar) 
            case 34:
                TestChar("(Shift-JIS)",sChar) 
            case 35:
                TestChar("(GB-2312)",sChar) 
            case 36:
                TestChar("(GBT-12345)",sChar) 
            case 37:
                TestChar("(GBK/GB-2312-80)",sChar) 
            case 38:
                TestChar("(Big5)",sChar) 
            case 39:
                TestChar("(EUC-JP)",sChar) 
            case 40:
                TestChar("(ISO-2022-JP)",sChar) 
            case 41:
                TestChar("(ISO-2022-CN)",sChar) 
            case 42:
                TestChar("(KOI8-R)",sChar)
            case 43:
                TestChar("(UTF-7)",sChar) 
            case 44:
                TestChar("(UTF-8)",sChar) 
            case 45:
                TestChar("(ISO-8859-10)",sChar) 
            case 46:
                TestChar("(ISO-8859-13)",sChar) 
            case 47:
                TestChar("(EUC-KR)",sChar) 
            case 48:
                TestChar("(ISO-2022-KR)",sChar) 
            case 49:
                TestChar("(Windows-Johab-1361)",sChar) 
            case 50:
                TestChar("(GB-18030)",sChar) 
            case 51:
                TestChar("(BIG5-HKSCS)",sChar) 
            case 52:
                TestChar("(ISO-8859-11/TIS-620)",sChar) 
            case 53:
                TestChar("(KOI8-U)",sChar) 
        end select      
  next  
  
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabAdabasStatistics
  '  TabControl.SetPageId(19213)
  sleep(2)
 Kontext "TabAdabasStatistics"
  call Dialogtest(TabAdabasStatistics)
  Extended.Click
  sleep(4)
 Kontext "Messagebox"
  if Messagebox.Exists(3) then
   if MessageBox.GetRT = 376 then
    Messagebox.OK
   end if
  end if
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabAdabasTwo
 Dim ListCountA as integer
 Dim CountOfPages as integer
 printlog "tab page Adabas when 'New data source'-button has been used"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  NewDataSource.Click
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  DatabaseType.Select(2)
 Kontext "DataSourceAdministration"
  CountOfPages = TabControl.GetPageCount
  printlog "Page count: " & CountOfPages
  if CountOfPages <> 7 then
       warnlog "There are not 7 tab pagesavailable! Bug!"
  end if
  sleep(1)
  ' check if it's OOo because in OOo the button newdatabase is not available.
  if gOOo = 0 then 
      Kontext "TabGeneral"
      if NewDatabase.IsEnabled then 
         NewDatabase.Click
        Kontext "Messagebox"
         if Messagebox.Exists(2) then
          if MessageBox.GetRT = 304 then
           Messagebox.Ok
          end if
         end if
        try
          Kontext "CreateNewAdabasDatabase"
           call Dialogtest(CreateNewAdabasDatabase)
           AdminPasswordBtn.Click
           Kontext "Passwort"
            call Dialogtest(Passwort)
            PasswortName.SetText "JustAnother"
            PasswortBestaetigen.SetText "DayInParadise"
            Passwort.OK
            Kontext "Messagebox"
              if Messagebox.Exists(2) then
               if Messagebox.GetRT = 304 then
                 Messagebox.OK
               end if
                else
                warnlog "Password verification failed!!!"
              end if
           Kontext "Passwort"
            Passwort.Cancel
          Kontext "CreateNewAdabasDatabase"
           ControlPasswordBtn.Click
           Kontext "Passwort"
            call Dialogtest(Passwort)
            Passwort.Cancel
           Kontext "CreateNewAdabasDatabase"
            DomainPasswordBtn.Click
           Kontext "Passwort"
            call Dialogtest(Passwort)
            Passwort.Cancel
           Kontext "CreateNewAdabasDatabase"
            SysDevSpaceBtn.Click
           Kontext "SpeichernDlg"
            call Dialogtest(SpeichernDlg)
            SpeichernDlg.Cancel
           Kontext "CreateNewAdabasDatabase"
            TransactionlogBtn.Click
           Kontext "SpeichernDlg"
            call Dialogtest(SpeichernDlg)
            SpeichernDlg.Cancel
           Kontext "CreateNewAdabasDatabase"
            DataDevSpaceBtn.Click
           Kontext "SpeichernDlg"
            call Dialogtest(SpeichernDlg)
            SpeichernDlg.Cancel
           Kontext "CreateNewAdabasDatabase"
            CreateNewAdabasDatabase.Cancel
         catch
        warnlog "The ADABAS variables exiting but Adabas Database does not work!"
       endcatch
      end if
  end if
  
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabODBC
 Kontext "TabODBC"
  call Dialogtest(TabODBC)
  ListCountA = Adabas_CharacterSet.GetItemCount
  if ListCountA <> 53 then
      warnlog "There should be 53 character sets available but there are " & ListCountA & " sets available!?"
  end if  
  Kontext "DataSourceAdministration"
  TabControl.SetPage TabAdabasStatistics
 '  TabControl.SetPageId(19213)
  sleep(2)
 Kontext "TabAdabasStatistics"
  call Dialogtest(TabAdabasStatistics)
  Extended.Click
  sleep(4)
 Kontext "Messagebox"
  if Messagebox.Exists(3) then
   if MessageBox.GetRT = 376 then
    Messagebox.OK
   end if
  end if
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabAdabasUserSettings
 Kontext "Messagebox"
  if Messagebox.Exists(3) then
   if MessageBox.GetRT = 376 then
    Messagebox.OK
   end if
  end if
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase
'-------------------------------------------------------------------------

testcase tTabJDBC 
 printlog "tab page JDBC"
  call hNewDocument
  '/// Tools / Data Sources
  ToolsDataSources
 Kontext "DataSourceAdministration"
  '/// Clicking on <i>New Data Source</i>
  NewDataSource.Click
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  '/// Selecting 1st entry of platform is<ul><li>Solaris x86</li><li>OS/2</li><li>MacOS</li></ul>
  if gPlatform = "x86" OR gPlatform = "os2" OR gPlatform = "os4" OR gPlatform = "mac" then
    DatabaseType.Select(2)
   else
    '/// Selecting 3th entry for all other platforms.
    DatabaseType.Select(3)
  end if
 Kontext "DataSourceAdministration"
  '/// Verifying that tabpage <i>JDBC</i> is selectable.
  TabControl.SetPage TabJDBC
 Kontext "TabJDBC"
  call Dialogtest(TabJDBC)
  Kontext "DataSourceAdministration"
  '/// Cancel <i>Data Source Administration</i>-dialog.
  DataSourceAdministration.Cancel
  call hCloseDocument
endcase

'-------------------------------------------------------------------------
testcase tTabODBC
 Dim ListCountA as integer
 dim i as integer 
 dim sChar as string
 '/// Description ///'
 printlog "tab page ODBC"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  NewDataSource.Click
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
   if gPlatform = "x86" OR gPlatform = "os2" OR gPlatform = "os4" OR gPlatform = "mac" then
    DatabaseType.Select(3)
   else
    '/// Selecting 3th entry for all other platforms.
    DatabaseType.Select(4)
  end if  
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabODBC
 Kontext "TabODBC"
  call Dialogtest(TabODBC)
  ListCountA = CharacterSet.GetItemCount  
  if ListCountA <> 53 then
    warnlog "There should be 53 character sets available but there are " & ListCountA & " sets available!?"
  end if  
  for i = 1 to ListCountA
        sChar = CharacterSet.GetItemText(i)
        select case i
            case 1:
                if iSprache = 33 then                
                    TestChar("Système",sChar)
                elseif iSprache = 34 then
                    TestChar("Sistema",sChar)
                elseif iSprache = 39 then
                    TestChar("Sistema",sChar)
                elseif iSprache = 55 then
                    TestChar("Sistema",sChar)
                elseif ( iSprache = 81 OR iSprache = 82 OR iSprache = 86 OR iSprache = 88 ) then
                    'do nothing, because I can't compare CJK characters
                else
                    TestChar("System",sChar)
                endif                
            case 2:            
                TestChar("(Windows-1252/WinLatin 1)",sChar)
            case 3:    
                TestChar("(Apple Macintosh)",sChar)
            case 4:   
                TestChar("(DOS/OS2-437/",sChar)
            case 5:  
                TestChar("(DOS/OS2-850/",sChar)
            case 6: 
                TestChar("(DOS/OS2-860/",sChar)
            case 7:
                TestChar("(DOS/OS2-861/",sChar)
            case 8:
                TestChar("(DOS/OS2-863/",sChar)
            case 9:
                TestChar("(DOS/OS2-865/",sChar)
            case 10:
                TestChar("(ASCII/",sChar)
            case 11:
                TestChar("(ISO-8859-1)",sChar)
            case 12:
                TestChar("(ISO-8859-2)",sChar)
            case 13:
                TestChar("(ISO-8859-3)",sChar)
            case 14:
                TestChar("(ISO-8859-4)",sChar)
            case 15:
                TestChar("(ISO-8859-5)",sChar)
            case 16:
                TestChar("(ISO-8859-6)",sChar)
            case 17:
                TestChar("(ISO-8859-7)",sChar)
            case 18:
                TestChar("(ISO-8859-8)",sChar)
            case 19:
                TestChar("(ISO-8859-9)",sChar)
            case 20:
                TestChar("(ISO-8859-14)",sChar)
            case 21:
                TestChar("(ISO-8859-15/",sChar)
            case 22:
                TestChar("(DOS/OS2-852)",sChar)
            case 23:
                TestChar("(DOS/OS2-862)",sChar)
            case 24:
                TestChar("(DOS/OS2-864)",sChar)
            case 25:
                TestChar("(DOS/OS2-866/",sChar)
            case 26:
                TestChar("(Windows-874)",sChar)
            case 27:
                TestChar("(Windows-1250/WinLatin 2)",sChar)
            case 28:
                TestChar("(Windows-1251)",sChar)
            case 29:
                TestChar("(Windows-1253)",sChar)
            case 30:
                TestChar("(Windows-1254)",sChar)
            case 31:
                TestChar("(Windows-1255)",sChar)                           
            case 32:
                TestChar("(Windows-1256)",sChar)                           
            case 33:
                TestChar("(Windows-1257)",sChar)
            case 34:
                TestChar("(Shift-JIS)",sChar)                           
            case 35:
                TestChar("(GB-2312)",sChar)
            case 36:
                TestChar("(GBT-12345)",sChar)                           
            case 37:
                TestChar("(GBK/GB-2312-80)",sChar)
            case 38:
                TestChar("(Big5)",sChar)                           
            case 39:
                TestChar("(EUC-JP)",sChar)
            case 40:
                TestChar("(ISO-2022-JP)",sChar)                           
            case 41:
                TestChar("(ISO-2022-CN)",sChar)
            case 42:
                TestChar("(KOI8-R)",sChar)
            case 43:
                TestChar("(UTF-7)",sChar)
            case 44:
                TestChar("(UTF-8)",sChar)                           
            case 45:
                TestChar("(ISO-8859-10)",sChar)
            case 46:
                TestChar("(ISO-8859-13)",sChar)                           
            case 47:
                TestChar("(EUC-KR)",sChar)
            case 48:
                TestChar("(ISO-2022-KR)",sChar)                           
            case 49:
                TestChar("(Windows-Johab-1361)",sChar)
            case 50:
                TestChar("(GB-18030)",sChar)                           
            case 51:
                TestChar("(BIG5-HKSCS)",sChar)
            case 52:
                TestChar("(ISO-8859-11/TIS-620)",sChar)
            case 53:
                TestChar("(KOI8-U)",sChar)
        end select      
  next  
  
  Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabdBase
 Dim b as integer
 Dim ListCountA as integer
 dim i as integer
 dim sChar as string
 '/// Description ///'
 printlog "tab page dBase"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  NewDatasource.Click
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  if gPlatform <> "os2" AND gPlatform <> "x86" AND gPlatform <> "os4" AND gPlatform <> "mac" then
    DatabaseType.Select(5)
   else
    DatabaseType.Select(4)
  end if
 Kontext "DataSourceAdministration"
  TabCOntrol.SetPage TabdBase
  for b= 1 to 2
   Kontext "Messagebox"
    if Messagebox.Exists(3) then
     if MessageBox.GetRT = 304 then
      if b = 2 then
       warnlog Messagebox.GetText
       warnlog "Why asking to times?"
      end if
      Messagebox.No
     end if
    end if
  next b
 Kontext "TabdBase"
  call Dialogtest(TabdBase)
  ListCountA = CharacterSet.GetItemCount
  if ListCountA <> 38 then
    warnlog "There should be 38 character sets available but there are " & ListCountA & " sets available!?"
  end if
  
  for i = 1 to ListCountA
        sChar = CharacterSet.GetItemText(i)
        select case i
            case 1:
                if iSprache = 33 then                
                    TestChar("Système",sChar)
                elseif iSprache = 34 then
                    TestChar("Sistema",sChar)
                elseif iSprache = 39 then
                    TestChar("Sistema",sChar)
                elseif iSprache = 55 then
                    TestChar("Sistema",sChar)
                elseif ( iSprache = 81 OR iSprache = 82 OR iSprache = 86 OR iSprache = 88 ) then
                    'do nothing, because I can't compare CJK characters
                else
                    TestChar("System",sChar)
                endif                
            case 2:            
                TestChar("(Windows-1252/WinLatin 1)",sChar)
            case 3:    
                TestChar("(Apple Macintosh)",sChar)
            case 4:   
                TestChar("(DOS/OS2-437/",sChar)
            case 5:  
                TestChar("(DOS/OS2-850/",sChar)
            case 6: 
                TestChar("(DOS/OS2-860/",sChar)
            case 7:
                TestChar("(DOS/OS2-861/",sChar)
            case 8:
                TestChar("(DOS/OS2-863/",sChar)
            case 9:
                TestChar("(DOS/OS2-865/",sChar)
            case 10:
                TestChar("(ASCII/",sChar)
            case 11:
                TestChar("(ISO-8859-1)",sChar)
            case 12:
                TestChar("(ISO-8859-2)",sChar)
            case 13:
                TestChar("(ISO-8859-3)",sChar)
            case 14:
                TestChar("(ISO-8859-4)",sChar)
            case 15:
                TestChar("(ISO-8859-5)",sChar)
            case 16:
                TestChar("(ISO-8859-6)",sChar)            
            case 17:
                TestChar("(ISO-8859-7)",sChar)
            case 18:
                TestChar("(ISO-8859-8)",sChar)            
            case 19:
                TestChar("(ISO-8859-9)",sChar)            
            case 20:
                TestChar("(ISO-8859-14)",sChar)
            case 21:
                TestChar("(ISO-8859-15/",sChar)
            case 22:
                TestChar("(DOS/OS2-852)",sChar)
            case 23:
                TestChar("(DOS/OS2-862)",sChar)
            case 24:
                TestChar("(DOS/OS2-864)",sChar)
            case 25:
                TestChar("(DOS/OS2-866/",sChar)
            case 26:
                TestChar("(Windows-874)",sChar)
            case 27:
                TestChar("(Windows-1250/WinLatin 2)",sChar)
            case 28:
                TestChar("(Windows-1251)",sChar)
            case 29:
                TestChar("(Windows-1253)",sChar)
            case 30:
                TestChar("(Windows-1254)",sChar)
            case 31:
                TestChar("(Windows-1255)",sChar)
            case 32:
                TestChar("(Windows-1256)",sChar)
            case 33:
                TestChar("(Windows-1257)",sChar)
            case 34:
                TestChar("(KOI8-R)",sChar)
            case 35:
                TestChar("(ISO-8859-10)",sChar)
            case 36:
                TestChar("(ISO-8859-13)",sChar)
            case 37:
                TestChar("(ISO-8859-11/TIS-620)",sChar)
            case 38:
                TestChar("(KOI8-U)",sChar)    
        end select      
  next
 
 Kontext "TabdBase"
  Indexes.Click
 Kontext "Indexes"
  call Dialogtest(Indexes)
  Indexes.Cancel
 
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabADO
 '/// Description ///'
 printlog "tab page ADO"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  DatabaseType.Select(6)
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabADO
 Kontext "TabADO"
  call Dialogtest(TabADO)
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabTEXTBase
 Dim b as integer
 Dim ListCountA as integer
 Dim ListCountB as integer
 Dim ListCountC as integer
 Dim ListCountD as integer
 Dim ListCountE as integer
 Dim ListCountF as integer
 dim i as integer
 dim sChar as string
 '/// Description ///'
 printlog "tab page TextBase"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  NewDatasource.Click
  TabCOntrol.SetPage TabGeneral
 Kontext "TabGeneral"
  if gPlatgroup = "w95" then
    DatabaseType.Select(7)
   else
    if gPlatform <> "os2" AND gPlatform <> "x86" AND gPlatform <> "os4" AND gPlatform <> "mac" then
      DatabaseType.Select(6)
     else
      DatabaseType.Select(5)
    end if
  end if
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabTextBase
  for b= 1 to 2
   Kontext "Messagebox"
    if Messagebox.Exists(3) then
     if MessageBox.GetRT = 304 then
      if b = 2 then
       warnlog Messagebox.GetText
       warnlog "Why asking to times?"
      end if
      Messagebox.No
     end if
   end if
  next b
 Kontext "TabTextBase"
  call Dialogtest(TabTextBase)
  '/// Field separator ///'
  ListCountA = FieldSeparator.GetItemCount
  if ListCountA <> 5 then
    warnlog "There should be 5 field separators available but there are " & ListCountA & " separators available!?"
  end if
  '/// Text separator ///'
  ListCountB = TextSeparator.GetItemCount
  if ListCountB <> 3 then
    warnlog "There should be 3 text separators available but there are " & ListCountB & " separators available!?"
  end if
  '/// Decimal separator ///'
  ListCountC = DecimalSeparator.GetItemCount
  if ListCountC <> 4 then
    warnlog "There should be 4 decimal separators available but there are " & ListCountC & " separators available!?"
  end if
  '/// Thousands separator ///'
  ListCountD = ThousandsSeparator.GetItemCount
  if ListCountD <> 2 then
    warnlog "There should be 2 thousands separators available but there are " & ListCountD & " separators available!?"
  end if
  '/// Extensions ///'
  ListCountE = Extension.GetItemCount
  if ListCountE <> 3 then
    warnlog "There should be 3 extensions available but there are " & ListCountE & " extensions available!?"
  end if
  '/// Character set ///'
  ListCountF = CharacterSet.GetItemCount
  if ListCountF <> 38 then
    warnlog "There should be 38 character sets available but there are " & ListCountF & " sets available!?"
  end if
  
  for i = 1 to ListCountF
        sChar =  CharacterSet.GetItemText(i)
        select case i
            case 1:
                if iSprache = 33 then                
                    TestChar("Système",sChar)
                elseif iSprache = 34 then
                    TestChar("Sistema",sChar)
                elseif iSprache = 39 then
                    TestChar("Sistema",sChar)
                elseif iSprache = 55 then
                    TestChar("Sistema",sChar)
                elseif ( iSprache = 81 OR iSprache = 82 OR iSprache = 86 OR iSprache = 88 ) then
                    'do nothing, because I can't compare CJK characters
                else
                    TestChar("System",sChar)
                endif                
            case 2:            
                TestChar("(Windows-1252/WinLatin 1)",sChar)
            case 3:    
                TestChar("(Apple Macintosh)",sChar)
            case 4:   
                TestChar("(DOS/OS2-437/",sChar)
            case 5:  
                TestChar("(DOS/OS2-850/",sChar)
            case 6: 
                TestChar("(DOS/OS2-860/",sChar)
            case 7:
                TestChar("(DOS/OS2-861/",sChar)
            case 8:
                TestChar("(DOS/OS2-863/",sChar)
            case 9:
                TestChar("(DOS/OS2-865/",sChar)
            case 10:
                TestChar("(ASCII/",sChar)
            case 11:
                TestChar("(ISO-8859-1)",sChar)
            case 12:
                TestChar("(ISO-8859-2)",sChar)
            case 13:
                TestChar("(ISO-8859-3)",sChar)
            case 14:
                TestChar("(ISO-8859-4)",sChar)
            case 15:
                TestChar("(ISO-8859-5)",sChar)
            case 16:
                TestChar("(ISO-8859-6)",sChar)            
            case 17:
                TestChar("(ISO-8859-7)",sChar)
            case 18:
                TestChar("(ISO-8859-8)",sChar)            
            case 19:
                TestChar("(ISO-8859-9)",sChar)            
            case 20:
                TestChar("(ISO-8859-14)",sChar)
            case 21:
                TestChar("(ISO-8859-15/",sChar)
            case 22:
                TestChar("(DOS/OS2-852)",sChar)
            case 23:
                TestChar("(DOS/OS2-862)",sChar)
            case 24:
                TestChar("(DOS/OS2-864)",sChar)
            case 25:
                TestChar("(DOS/OS2-866/",sChar)
            case 26:
                TestChar("(Windows-874)",sChar)
            case 27:
                TestChar("(Windows-1250/WinLatin 2)",sChar)
            case 28:
                TestChar("(Windows-1251)",sChar)
            case 29:
                TestChar("(Windows-1253)",sChar)
            case 30:
                TestChar("(Windows-1254)",sChar)
            case 31:
                TestChar("(Windows-1255)",sChar)
            case 32:
                TestChar("(Windows-1256)",sChar)
            case 33:
                TestChar("(Windows-1257)",sChar)
            case 34:
                TestChar("(KOI8-R)",sChar)
            case 35:
                TestChar("(ISO-8859-10)",sChar)
            case 36:
                TestChar("(ISO-8859-13)",sChar)
            case 37:
                TestChar("(ISO-8859-11/TIS-620)",sChar)
            case 38:
                TestChar("(KOI8-U)",sChar)    
        end select      
  next  

 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------
testcase tTabSpreadsheet
 Dim CountOfPages as integer
 printlog "tab page Spreadsheet"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  if gPlatgroup = "w95" then
    DatabaseType.Select(8)
   else
    if gPlatform <> "os2" AND gPlatform <> "x86" AND gPlatform <> "os4" AND gPlatform <> "mac" then
      DatabaseType.Select(7)
     else
      DatabaseType.Select(6)
    end if
  end if
 Kontext "DataSourceAdministration"
  CountOfPages = TabControl.GetPageCount
  printlog "Page count: " & CountOfPages
  if CountOfPages <> 4 then
       warnlog "There are not 4 tab pagesavailable! Bug!"
  end if
 Kontext "TabGeneral"
  SelectPath.Click
 Kontext "OeffnenDlg"
  call Dialogtest(OeffnenDlg)
  OeffnenDlg.Cancel
  sleep(1)
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase
'-------------------------------------------------------------------------
sub TestChar(s1,s2)

    if (Instr(s2,s1) = 0) then
        warnlog "The character set isn't right. I should be '" + s1 + "' but it is '" + s2 + "'"
    endif
    
end sub

