'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_basic_2.inc,v $
'*
'*  $Revision: 1.1.2.3 $
'*
'*  last change: $Author: jsi $ $Date: 2003/09/09 13:11:02 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : check macro-dialogs / BASIC-IDE (2. part)
'*
'*******************************************************************************
' **
' #1 tBasic_IDE_Toolbar_Module        ' update-test for Toolbar in Basic-IDE
' #1 tBasic_IDE_Toolbar_Dialogs       ' check macro bar for a new dialog
' #1 tMore_Modules_Dialogs            ' create 10 modules, 10 dialogs, delete all new modules/dialogs and delete the last one
' #1 tDeleteModulesAtRunningBasic     ' try to reproduce #99400
' #0 tWatch_Calls                     ' run a script and have a look at watches and calls
' #1 tAllControlsOnDialog             ' insert all controls in all documents, save/close/reload the docs and check all controls
' **
'\******************************************************************************

testcase tBasic_IDE_Toolbar_Module
'///Work with Toolbar on Basic-IDE
'///Open a new writer-doc
printlog "open a new writer-doc"
gApplication = "Writer"
Call hNewDocument
'///create a new module for the new document (named TTModule)    
    Call CreateNewModuleForDoc
    printlog "create a new module "
    '///+ now the basic-IDE is open
    Kontext "MacroBar"
        '///+activate "Compile" on Toolbar
        printlog "- compile"
        Compile.Click
        sleep(1)
        '///+activate "Run Basic" on Toolbar
        printlog "- Run Basic"
        BasicRun.Click
        sleep(1)
        '///+activate "Step Procedure" on Toolbar
        printlog "- Step Procedure"
        ProcedureStep.Click
        sleep(1)
        '///+activate "Stop Basic" on Toolbar
        printlog "- Stop Basic"
        BasicStop.Click
        sleep(1)
        '///+activate "Single Step" on Toolbar
        printlog "- Single Step"
        SingleStep.Click
        sleep(1)
        '///+activate "Step Back" on Toolbar
        printlog "- Step Back"
        StepBack.Click
        sleep(1)
        '///+activate "Breakpoint" on Toolbar
        printlog "- Breakpoint => activate"
        Breakpoint.Click
        sleep(1)
        '///+deactivate "Breakpoint" on Toolbar
        printlog "- Breakpoint => deactivate"
        Breakpoint.Click
        sleep(1)
        '///+activate "Add Watch" on Toolbar
        printlog "- Add Watch => deactivate"
        AddWatch.Click
        sleep(1)
        '///+activate "Object Catalog" on Toolbar => close 'Object'-Dialog
        printlog "- Object Catalog => deactivate"
        ObjectCatalog.Click
        sleep(1)
        Kontext "Objekte"
            Call DialogTest (Objekte)
            Objekte.Close
        '///+activate "Macros" on Toolbar => close 'Macro'-Dialog
        printlog "- Macros"
        Kontext "MacroBar"
            Macros.Click
            sleep(1)
            Kontext "Makro"
                Makro.Close
            '///+activate "Modules" on Toolbar => close 'Modules'-TabDialog
            Kontext "MacroBar"
                printlog "- Modules"
                Modules.Click
                sleep(1)
            Kontext
                Active.SetPage TabModule
                sleep(1)
                Active.SetPage TabBibliotheken
                Kontext "TabBibliotheken"
                TabBibliotheken.Close
            '///+activate "Find Paranthese" on Toolbar
            printlog "- Find Paranthese"
        Kontext "MacroBar"
            FindParanthese.Click
            sleep(1)
            '///+"Controls" should be disabled when a module is open
            printlog "- 'controls'-button must be disabled for modules"
            try
                Controls.TearOff
                warnlog "Controls are active in a module window => bug!"
            catch
            endcatch
            sleep(1)
            printlog "- Insert Source Text ([TesttoolPath]\framework\basic\input\resetregistration.bas)"
            '///+activate "Insert Source Text" on Toolbar
            '///+- insert [TesttoolPath]\framework\update\input\basic\resetregistration.bas
            InsertSourceText.Click
            sleep(1)
            Kontext "OeffnenDlg"
                Dateiname.SetText ConvertPath (gTesttoolpath + "framework\basic\input\resetregistration.bas")
                Oeffnen.CLick
                sleep(1)
            Kontext "MacroBar"
                printlog "- Save Source Test "
                '///+activate "Save Source Test" on Toolbar
                '///+- save it as bas-file
                SaveSourceTest.Click
                sleep(1)
                Kontext "SpeichernDlg"
                    Dateiname.SetText ConvertPath (gOfficepath + "user\work\global_test.bas")
                    Speichern.CLick
                    sleep(1)
                    Kontext "Active"
                        if Active.Exists then Active.Yes
                        sleep(1)
                        '///+file/close for Basic-IDE and Document
    Call hCloseDocument   ' for Basic-IDE
Call hCloseDocument   ' the new writer-doc
endcase

'-------------------------------------------------------------------------

testcase tBasic_IDE_Toolbar_Dialogs
'///work with Toolbar on Basic-IDE
'///open a new writer-doc
printlog "open a new writer-doc"
gApplication = "WRITER"
Call hNewDocument
    '///create a new module for the new document (named TTModule)
    printlog "create a new module "
    Call CreateNewModuleForDoc
    '///create a new dialog in BasicIDE
    Kontext "BasicIDE"
        Tabbar.OpenContextMenu
        hMenuSelectNr (1)
        sleep(1)
        hMenuSelectNr (2)
        sleep(2)
        if DialogWindow.Exists (2) <> TRUE then 
            warnlog "No dialog window is shown!"
        end if
        '///+=> now the basic-IDE is open
        Kontext "MacroBar"
            '///+"Compile" (disabled)
            printlog "- compile (disabled)"
            try
                Compile.Click
                warnlog "Compile : is not disabled"
            catch
            endcatch
            sleep(1)
            '///+"Run Basic" (disabled)
            printlog "- Run Basic (disabled)"
            try
                BasicRun.Click
                warnlog "Run : is not disabled"
            catch
            endcatch
            sleep(1)
            '///+"Step Procedure" (disabled)
            printlog "- Step Procedure (disabled)"
            try
                ProcedureStep.Click
                warnlog "Step Procedure : is not disabled"
            catch
            endcatch
            sleep(1)
            '///+"Stop Basic" (disabled)
            printlog "- Stop Basic (disabled)"
            try
                BasicStop.Click
                warnlog "Stop Basic : is not disabled"
            catch
            endcatch
            sleep(1)
            '///+"Single Step" (disabled)
            printlog "- Single Step (disabled)"
            try
                SingleStep.Click
                warnlog "Single Step : is not disabled"
            catch
            endcatch
            sleep(1)
            '///+"Step Back" (disabled)
            printlog "- Step Back (disabled)"
            try
                StepBack.Click
                warnlog "Single Step : is not disabled"
            catch
            endcatch
            sleep(1)
            '///+"Breakpoint" (disabled)
            printlog "- Breakpoint  (disabled)"
            try
                Breakpoint.Click
                warnlog "Breakpoint : is not disabled"
            catch
            endcatch
            sleep(1)
            '///+"Add Watch" (disabled)
            printlog "- Add Watch  (disabled)"
            try
                AddWatch.Click
                warnlog "Add Watch : is not disabled"
            catch
            endcatch
            sleep(1)
            '///+activate "Object Catalog" on Toolbar => close 'Object'-Dialog
            printlog "- Object Catalog => deactivate"
            ObjectCatalog.Click
            sleep(1)
            Kontext "Objekte"
                Call DialogTest (Objekte)
                Objekte.Close
            '///+activate "Macros" on Toolbar => close 'Macro'-Dialog
            printlog "- Macros"
            Kontext "MacroBar"
                Macros.Click
                sleep(1)
                Kontext "Makro"
                    Makro.Close
                '///+activate "Modules" on Toolbar => close 'Modules'-TabDialog
            printlog "- Modules"
            Kontext "MacroBar"
                Modules.Click
                sleep(1)
                Kontext
                    Active.SetPage TabModule
                    sleep(1)
                    Active.SetPage TabBibliotheken
                    Kontext "TabBibliotheken"
                    TabBibliotheken.Close
            Kontext "MacroBar"
                printlog "- Find Paranthese (disabled)"
                '///+"Find Paranthese" (disabled)
                try
                    FindParanthese.Click
                    warnlog "Find Paranthese : is not disabled"
                catch
                endcatch
                sleep(1)
                '///+tear off controls
                printlog "- tear off 'controls'"
                Controls.TearOff
                sleep(2)
                Kontext "TB_MacroControls"
                    if TB_MacroControls.Exists <> TRUE then
                        warnlog "Controls-window is not open!"
                    else
                        TB_MacroControls.Move (50, 50)
                        TB_MacroControls.Close
                    end if
                    sleep(1)
            Kontext "MacroBar"
                printlog "- Insert Source Text  (disabled))"
                '///+"Insert Source Text" (disabled)
                try
                    InsertSourceText.Click
                    warnlog "Insert Source Text : is not disabled"
                    sleep(1)
                    Kontext "OeffnenDlg"
                        Dateiname.SetText ConvertPath (gTesttoolpath + "framework\basic\input\resetregistration.bas")
                        Oeffnen.Click
                catch
                endcatch
                sleep(1)
            Kontext "MacroBar"
                printlog "- Save Source Test  (disabled)"
                '///"Save Source Text" (disabled)
                '///+<nbr><nbr>save it as bas-file
                try
                    SaveSourceTest.Click
                    warnlog "Save Source Text : is not disabled"
                    sleep(1)
                    Kontext "SpeichernDlg"
                        Dateiname.SetText ConvertPath (gOfficepath + "user\work\global_test.bas")
                        Speichern.Click
                        sleep(1)
                        Kontext "Active"
                            if Active.Exists then Active.Yes
                            sleep(1)
                catch
                endcatch
                '///+file/close for Basic-IDE and Document
    Call hCloseDocument   ' for Basic-IDE
Call hCloseDocument   ' the new writer-doc
endcase

'-------------------------------------------------------------------------

testcase tMore_Modules_Dialogs
Dim i as Integer
'const icTen is the number of dialogs and modules. 
'If icTen = 10 then 20 tabs (+ the first one!) = 21 should be created. 
const icTen as Integer = 10
'///Work with macros
'///Create a new Writer document.
printlog "open a new writer-doc"
gApplication = "WRITER"
Call hNewDocument
    '///+Create a new module for the new document (named TTModule)
    printlog "create a new module "
    Call CreateNewModuleForDoc
        '///+Insert 10 modules.
        printlog "insert 10 modules"
        for i=1 to icTen
            printlog "   - insert new module : " & i
            Kontext "BasicIDE"
                Tabbar.OpenContextMenu
                hMenuSelectNr(1)
                sleep(1)
                hMenuSelectNr(1)
                sleep(2)
                EditWindow.TypeKeys "<Up>", 20
                EditWindow.TypeKeys "<Mod1 a>"
                EditWindow.TypeKeys "<Delete>"
                EditWindow.TypeKeys "'# " & (i+1) & ". module in this document"
        next i
        '///+Insert 10 dialogs
        printlog "insert 10 dialogs"
        for i=1 to icTen
            printlog "   - insert new dialog : " & i
            Tabbar.OpenContextMenu
            hMenuSelectNr(1)
            sleep(1)
            hMenuSelectNr (2)
            sleep(2)
            if DialogWindow.Exists (2) <> TRUE then 
                warnlog "No dialog window is shown!"
            end if
        next i        
        '///+Close the BasicIDE.
        printlog Chr(13) + "- close the BasicIDE"
        Call hCloseDocument
        '///+Save the document.
        printlog Chr(13) + "- save the document"
        Call hSpeichernUnterKill(gOfficePath & "user\work\basic.sxw")
        '///+Close the document
        printlog Chr(13) + "- close the document"
        Call hCloseDocument
        '///+Open the saved document
        printlog Chr(13) + "- open the saved document"
        Call hDateiOeffnen (gOfficePath + "user\work\basic.sxw" , TRUE)
        Call SelectTheLastModule (TRUE, FALSE)
        '///+Select the last module and open the BASIC IDE.
        Bearbeiten.Click
        '///+Delete all modules dialogs.
        printlog "delete all modules and dialogs"        
        for i=1 to ((2 * icTen)+1)
                try
                    printlog "delete  - " & i & "/" & ((2 * icTen)+1) 
                    UseBindings
                    Kontext "BasicIDE"                    
                        Tabbar.OpenContextMenu
                        sleep(2)
                        hMenuSelectNr(2)
                        sleep(1)
                    Kontext "Active"
                        if Active.Exists then
                            Active.Yes
                        else
                            warnlog "No warning after deleting a dialog!"
                        end if
                catch
                    QAErrorLog "Deleting  - " & i & "/" & ((2 * icTen)+1) & " failed."
                endcatch
        next i
    Call hCloseDocument
Call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tDeleteModulesAtRunningBasic
Dim i as Integer
Dim iSel as Integer
'///work with macros
'///open a new writer-doc
printlog "open a new writer-doc"
gApplication = "Writer"
Call hNewDocument
    '///create a new module for the new document (named TTModule)
    printlog "create a new module "
    Call CreateNewModuleForDoc
    '///insert a short script (1. page)
    printlog "insert a short script (1. page)"
    Kontext "BasicIDE"
        EditWindow.TypeKeys "<Mod1 a>"
        EditWindow.TypeKeys "<Delete>"
        EditWindow.TypeKeys "'# This is a short testscript for automated testing!<return><return>"
        EditWindow.TypeKeys "sub main<return><return>"
        EditWindow.TypeKeys "print " + Chr (34) + "hallo" + Chr (34) + "<Return><Return>"
        EditWindow.TypeKeys "<Home>end sub<return>"
    Kontext "MacroBar"
        printlog "- Click button:  Step Procedure"
        '///+activate "Step Procedure" on Toolbar
        ProcedureStep.Click
        sleep(3)
        '///+check if disabled menu-items are shown and delete is not shown
    Kontext "BasicIDE"
        printlog "check if disabled menu items are shown in context menu and 'delete' is not shown"
        Tabbar.OpenContextMenu
        try
            if hMenuItemGetCount = 5 then 
                warnlog "Disabled entries are shown in context menu on tab bar => bugID 101972"
            end if
            if hMenuItemGetCount = 3 then 
                warnlog "Delete is active in context menu for a running macro => BUG!"
            end if
        catch
            warnlog "Unable to retrieve the number of menuitems"
        endcatch
    hMenuClose
    '///+stop the running script
    printlog "Stop the running script"
    Kontext "MacroBar"
        BasicStop.Click
        sleep(1)
        '///+close the BasicIDE and the document
        printlog "close the documents"
    Call hCloseDocument
Call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tWatch_Calls
Dim i as Integer 
Dim iCut as Integer
Dim sTemp as String
'///run a short script and have a look at watches and calls
'///open a new writer-doc
printlog "open a new writer-doc"
gApplication = "Writer"
Call hNewDocument
    '///+create a new module for the new document (named TTModule)
    printlog "create a new module "
    Call CreateNewModuleForDoc
    '///+insert a short script
    '///(with 'sub main' which calls another sub-routine, and a for-next-loop)
    printlog "insert a short script (with 'sub main' which calls another sub-routine)"
    Kontext "BasicIDE"
        EditWindow.TypeKeys "<Mod1 a>"
        EditWindow.TypeKeys "<Delete>"
        EditWindow.TypeKeys "'# This is a short testscript for automated testing!<return><return>"
        EditWindow.TypeKeys "sub main<return><return>"
        EditWindow.TypeKeys "call PrintHello<return><return>"
        EditWindow.TypeKeys "<Home>end sub<return><return><return>"
        EditWindow.TypeKeys "sub PrintHello<Return>"
        EditWindow.TypeKeys "dim i as Integer<Return><Return>"
        EditWindow.TypeKeys "for i=1 to 10<Return>"
        EditWindow.TypeKeys "if i=5 OR i=10 then<Return>"
        EditWindow.TypeKeys "print " + Chr (34) + "hallo" + Chr (34) + "<Return>"
        EditWindow.TypeKeys "end if<Return>"
        EditWindow.TypeKeys "next i<Return>"
        EditWindow.TypeKeys "<Home>end sub<Return>"
        '///+insert a breakpoint
        printlog "insert a breakpoint in the for-next loop"
        for i=20 to 50
            EditWindow.MouseDoubleClick (1, 2*i)
            try
                EditCopy
            catch
                SetClipboard ("")
            endcatch
            if lcase (GetClipboardText) = "if" then
                BreakPointsWindow.MouseDoubleClick (50, 2*i)
                i=50
            end if
        next i
        '///+add 2 variables to watch (1. a unused and undefined variable / 2. the variable of the counter for for-next-loop)
        printlog "add 2 variables to watch (1. a unused and undefined variable / 2. the variable of the counter for for-next-loop)"
        Kontext "BasicIDE"
            WatchEdit.TypeKeys("hello<Return>", TRUE)
            WatchEdit.TypeKeys("i<Return>", TRUE)
            WatchList.Select(1)
            if WatchList.GetSelText() <> "hello = " then 
                warnlog("Watch entry mismatch:")
                printlog("Should be: 'hello = '")
                printlog("Is.......: '" + WatchList.getSelText() + "'")
            end if
            WatchList.Select(2)
            if WatchList.GetSelText() <> "i = " then
                warnlog("Watch entry mismatch:")
                printlog("Should be: 'i = '")
                printlog("Is.......: '" + WatchList.getSelText() + "'")
            end if
            '///+start the script (click on run on the object bar)
            printlog "start the script"
            Kontext "MacroBar"
                BasicRun.Click()
                sleep(1)
                '///+check the variables in watch-window
                '///+ - the unused and undefined variable must have an error/undefined message (will be checked for each language)
                printlog "check te variables in watch"
                printlog "    1. unused and undefinded variable 'hello' must have an error/undefined message"
        Kontext "BasicIDE"
            WatchList.Select(1)
            sTemp = WatchList.GetSelText()
            iCut = Instr (sTemp, "hello =")
            if iCut = 0 then
                Warnlog "1. watch is not 'hello'!"
            else
                if Instr (sTemp, "<") = 0 or Instr (sTemp, ">") = 0 then
                    Warnlog "no correct error-message for the unused variable 'hello'"
                else
                    'printlog "      comparison of the message"
                    'nobody knows what the following stement does.
                    'hAppendCompareLanguageEntryToList (gTesttoolPath + "framework\basic\input\watch_err.txt", Mid (sTemp, iCut, Len (sTemp)-iCut))
                end if
            end if
            '///+ - the 2. variable must be '1' (first run in the for-next-loop)
            printlog "    2. variable 'i' must be '1' for the first loop!"
            WatchList.Select(2)
            sTemp = WatchList.GetSelText()
            iCut = Instr (sTemp, "i =")
            if iCut = 0 then
                warnlog "2. watch is not 'i'!"
            else
                if Right (sTemp, 1) <> "1" then Warnlog "'i' is not '= 1'!"
            end if
            '///check the variables in watch-window
            '///+- first entry must be 'PrintHello'
            '///+- second entry must be 'Main'
            printlog "check the Calls"
            CallsList.Select(1)
            if CallsList.GetSelText <> " 0: PrintHello" then 
                warnlog "The first call must be ' 0: PrintHello' but it is '" + CallsList.GetSelText + "'"
            end if
            CallsList.Select(2)
            if CallsList.GetSelText() <> " 1: Main" then 
                warnlog "The second call must be ' 1: Main' but it is '" + CallsList.GetSelText + "'"
            end if
            '///check the variables in watch-window for the next runs
            '///+click on run in object toolbar (4 times)
            printlog "click on run in object toolbar (4 times)"
            Kontext "MacroBar"
                for i=1 to 4
                    BasicRun.Click()
                    sleep(1)
                next i
            '///+ - the 2. variable must be '5'
            printlog "    2. variable 'i' must be '5'"
            Kontext "BasicIDE"
                WatchList.Select(2)
                sTemp = WatchList.GetSelText()
                iCut = Instr (sTemp, "i =")
                if iCut = 0 then
                    warnlog "2. watch is not 'i'!"
                else
                    if Right (sTemp, 1) <> "5" then Warnlog "'i' is not '= 1'!"
                end if
                '///+ - break the test, if you click on run in toolbar and cancel the print-box
                printlog "    break the test, if you click on run in toolbar and cancel the print-box"
                Kontext "MacroBar"
                    BasicRun.Click
                    Kontext "MessageBox"
                        if MessageBox.Exists() then
                            MessageBox.cancel()
                            sleep(1)
                            Kontext "MessageBox"
                                MessageBox.OK()
                        else
                            warnlog "The print-command does not call a messagebox => Bug!"
                            Kontext "MacroBar"
                                BasicStop.Click()
                        end if
                    '///+close the open BasicIDE and the new document
                    printlog "close the open BasicIDE and the new document"
    Call hCloseDocument
Call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tAllControlsOnDialog
Dim i as Integer , j as Integer
Dim sFile as String
'///<b>save/load-test for controls on a basic-dialog in all applications</b>
'///open a new doc (for all applications)
for j=1 to 4
    select case j
        case 1 : gApplication = "Writer"  : sFile = "w_basic.sxw"
        case 2 : gApplication = "Calc"    : sFile = "c_basic.sxc"        
        case 3 : gApplication = "Draw"    : sFile = "d_basic.sxd"
        case 4 : gApplication = "Impress" : sFile = "i_basic.sxi"
    end select
    printlog Chr(13) + "open a new " + gApplication + "-doc"
    call hNewDocument
    '///create a new module for the new document (named TTModule)
    printlog "create a new module "
    Call CreateNewModuleForDoc
    '///create a new dialog in BasicIDE
    Kontext "BasicIDE"
        Tabbar.OpenContextMenu
        hMenuSelectNr (1)
        sleep(1)
        hMenuSelectNr (2)
        sleep(2)
        if DialogWindow.Exists (2) <> TRUE then
            warnlog "No dialog window is shown!"
        end if
        Kontext "MacroBar"
        '///+tear off controls
        printlog "- tear off 'controls'"
        Controls.TearOff
        sleep(1)
        Kontext "TB_MacroControls"
            if TB_MacroControls.Exists <> TRUE then
                warnlog "Controls-window is not open!"
            else
                TB_MacroControls.Move (50 , 50)
            end if
            sleep(1)
        '///+- CommandButton
        printlog " - CommandButton"
        CommandButton.Click
        DrawControlOnDialog (35, 30, 40, 35)
        '///+- CheckBox
        printlog " - CheckBox"
        CheckBox.Click
        DrawControlOnDialog (35, 37, 40, 42)
        '///+- Label
        printlog " - Label"
        Label.Click
        DrawControlOnDialog (35, 45, 40, 50)
        '///+- ListBox
        printlog " - ListBox"
        ListBox.Click
        DrawControlOnDialog (35, 52, 40, 57)
        '///+- HScrollBar
        printlog " - HScrollBar"
        HScrollBar.Click
        DrawControlOnDialog (35, 60, 40, 65)
        '///+- FrameControl
        printlog " - FrameControl"
        FrameControl.Click
        DrawControlOnDialog (35, 67, 40, 72)
        '///+- NumericField
        printlog " - NumericField"
        NumericField.Click
        DrawControlOnDialog (42, 30, 47, 35)
        '///+- FormattedField
        printlog " - FormattedField"
        FormattedField.Click
        DrawControlOnDialog (42, 37, 47, 42)
        '///+- FileControl
        printlog " - FileControl"
        FileControl.Click
        DrawControlOnDialog (42, 45, 47, 50)
        '///+- ImageControl
        printlog " - ImageControl"
        ImageControl.Click
        DrawControlOnDialog (42, 52, 47, 57)
        '///+- OptionButton
        printlog " - OptionButton"
        OptionButton.Click
        DrawControlOnDialog (42, 60, 47, 65)
        '///+- TextField
        printlog " - TextField"
        TextField.Click
        DrawControlOnDialog (42, 67, 47, 72)
        '///+- DateField
        printlog " - DateField"
        DateField.Click
        DrawControlOnDialog (50, 30, 55, 35)
        '///+- VScrollBar
        printlog " - VScrollBar"
        VScrollBar.Click
        DrawControlOnDialog (50, 37, 55, 42)
        '///+- Progressbar
        printlog " - Progressbar"
        Progressbar.Click
        DrawControlOnDialog (50, 45, 55, 50)
        '///+- VLine
        printlog " - VLine"
        VLine.Click
        DrawControlOnDialog (50, 52, 55, 57)
        '///+- TimeField
        printlog " - TimeField"
        TimeField.Click
        DrawControlOnDialog (50, 60, 55, 65)
        '///+- CurrencyField
        printlog " - CurrencyField"
        CurrencyField.Click
        DrawControlOnDialog (50, 67, 55, 72)
        '///+- HLine
        printlog " - HLine"
        HLine.Click
        DrawControlOnDialog (57, 30, 62, 35)
        '///+- PatternField
        printlog " - PatternField"
        PatternField.Click
        DrawControlOnDialog (57, 37, 62, 42)
        '///+- ComboBox
        printlog " - ComboBox"
        ComboBox.Click
        DrawControlOnDialog (57, 45, 62, 50)
        '///close the Basic-IDE
        printlog "close the BASIC IDE"
        FileClose
        '///+save the document
        printlog " save the document"
        Call hSpeichernUnterKill (gOfficePath & "user\work\" & sFile)
        '///+close the document
        printlog " close it"
        FileClose
        sleep(2)
        '///check all controls in the saved document
        '///+open the document
        printlog " open the file again"
        Call hDateiOeffnen (gOfficePath & "user\work\" & sFile)
        '///+open the basic-IDE of this document, open controls, activate 'Select-mode' and open the properties
        printlog " open tools/macro and select the "
        call SelectTheLastModule (TRUE, FALSE)
        sleep(1)
        Bearbeiten.Click
        sleep(2)
        Kontext "BasicIDE"
            for i=1 to 20
                Tabbar.MouseDown (5*i,50)
                Tabbar.MouseUp (5*i,50)
                if DialogWindow.Exists then i=100
            next i
            Kontext "MacroBar"
                '///+tear off controls
                printlog "- tear off 'controls'"
                Controls.TearOff
                sleep(1)
                Kontext "TB_MacroControls"
                    if TB_MacroControls.Exists <> TRUE then
                        warnlog "Controls-window is not open!"
                    else
                        TB_MacroControls.Move (50, 50)
                    end if
                    sleep(1)
                    '///+activate select mode and the properties
                    printlog " activate select mode"
                    SelectMode.Click
                    '///+- check name of all controls
                    CheckControlsShort (37 , 33 , "CommandButton1")
                    CheckControlsShort (37 , 40 , "CheckBox1")
                    CheckControlsShort (37 , 48 , "Label1")
                    CheckControlsShort (37 , 55 , "Listbox1")
                    CheckControlsShort (37 , 63 , "ScrollBar1")
                    CheckControlsShort (37 , 70 , "FrameControl1")
                    CheckControlsShort (45 , 32 , "NumericField1")
                    CheckControlsShort (45 , 40 , "FormattedField1")
                    CheckControlsShort (45 , 48 , "FileControl1")
                    CheckControlsShort (45 , 55 , "ImageControl1")
                    CheckControlsShort (45 , 63 , "OptionButton1")
                    CheckControlsShort (45 , 70 , "TextField1")
                    CheckControlsShort (52 , 32 , "DateField1")
                    CheckControlsShort (52 , 40 , "ScrollBar2")
                    CheckControlsShort (52 , 48 , "Progressbar1")
                    CheckControlsShort (52 , 55 , "FixedLine1")
                    CheckControlsShort (52 , 63 , "TimeField1")
                    CheckControlsShort (52 , 70 , "CurrencyField1")
                    CheckControlsShort (60 , 32 , "FixedLine2")
                    CheckControlsShort (60 , 40 , "PatternField1")
                    CheckControlsShort (60 , 48 , "ComboBox1")
        Call hCloseDocument
    Call hCloseDocument
next j
gApplication = "WRITER"
endcase

