'*************************************************************************
'*
'*  $RCSfile: w_tool4.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:53:33 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************
'*                                                                **
'* owner : helge.delfs@sun.com                                    **
'*                                                                **
'* short description : Description of file                        **
'*                                                                **
'*******************************************************************
'*                                                                **
' #1 CountItemsInNavigatorGroup(Group as integer) as Integer
'*                                                                **
'\******************************************************************




function CountItemsInNavigatorGroup(Group as integer) as Integer
 Dim j as integer,SelectInNavigator as integer
 'First, select the Navigator depending on the application
 Kontext "Navigator"
 If Not Navigator.Exists then EditNavigator
 Kontext "NavigatorWriter"

 'In Navigator, close all groups and set focus to first group
 Sleep 2
 if Auswahlliste.GetItemCount<11 then Inhaltsansicht.Click
  Wait 500
  'Close all groups in Navigator
  if Auswahlliste.GetItemCount >11 then
   For j= 1 to 11
    Auswahlliste.Select j
    Auswahlliste.TypeKeys "-"
   next j
 endif

 Wait 500
 'Select group given by the function
 Auswahlliste.Select Group
 ' Open group
 Auswahlliste.TypeKeys "+"
 Inhaltsansicht.Click
 CountItemsInNavigatorGroup = Auswahlliste.GetItemCount - 1
 Inhaltsansicht.Click

end function


function wCheckOutline(WhatToFind as string) as boolean
     ' This function checks the Outline in level 1 test.
     ' Purpose is to have a little tolerance, because when resolution changes, the
     ' line breaks are different
     wCheckOutline = False
     Kontext "DocumentImpressOutlineView"
     DocumentImpressOutlineView.TypeKeys "<Home><Down>" ,1
     DocumentImpressOutlineView.TypeKeys "<Home><Shift End>"
     EditCopy
     if GetClipboardText <> WhatToFind then
        DocumentImpressOutlineView.TypeKeys "<Home><Up>" ,2
        DocumentImpressOutlineView.TypeKeys "<Home><Shift End>"
        EditCopy
        if GetClipboardText = WhatToFind then
          wCheckOutline = True
        endif
     else
      wCheckOutline = True
     endif
end function
