'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: xm_updt.bas,v $
'*
'*  $Revision: 1.4.2.2 $
'*
'*  last change: $Author: jsi $ $Date: 2004/01/09 08:17:56 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**********************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : XML Math Update Test
'*
'\***********************************************************************************
 Global Isliste(250) as string
 Global OutputPath as string

sub main
 Dim Startes

       printlog "---------------------------------------------------------------------"
       printlog "-----        X M L  -  M A T H  -  U P D A T E T E S T          -----"
       printlog "---------------------------------------------------------------------"

   use "xml\update\inc\sxm_01.inc"
      
   call hStatusIn ("XML","xm_updt.bas" , "XML Math Update Test")
       call CreateWorkXMLExportDir ( "user\work\xml\math\update\" )
       SetClipboard "This is the first doc"
       EditPaste       
       startes = Now       
       call hEnablePrettyPrinting(1)
       printlog "------------------- sxm_01.inc ---------------------"
       call tunary_binary
       call trelations
       call tset_operations
       call tfunctions
       call toperators
       call tattributes
       call tothers
       call tbrackets
       call tformats
       call tall_commands
       call tall_commands_star_math_3
       call tall_selections
       call tannuities
       call tcauchy
       call tchemicalelement
       call tdefinitionstraightline
       call teffectiveannualinterestrate
       call thamiltonoperator
       call tinvestmentreturns
       call tlawoferrorpropagation
       call tlimes      
       call tlinearregression
       call tmaxwell
       call tscalarproduct
       call tsinus
       call tsquareroot
       call tstandarddeviation
       call tvectorproduct
   call hStatusOut

       printlog "---------------------------------------------------------------------"
       printlog "End: " & Date & ", " & Time & ". (" & wielange(Startes) & ")"
       printlog "---------------------------------------------------------------------"
end sub


sub LoadIncludeFiles
   use "global\system\inc\master.inc"
   use "global\system\inc\gvariabl.inc"
   use "global\tools\inc\t_dir.inc"
   use "global\tools\inc\t_lists.inc"
   use "global\tools\inc\t_xml2.inc"
   use "xml\tools\xmltool1.inc"
   Call GetUseFiles
   gApplication   = "MATH"
end sub

'-------------------------------------------------------------------------
