'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: base_02.inc,v $
'*
'*  $Revision: 1.5.2.2 $
'*
'*  last change: $Author: msc $ $Date: 2003/12/30 08:44:23 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**********************************************************************************
'*
'* owner : marc.schwanz@sun.com
'*
'* short description : Data Sources Administration, Autopilots, etc. for Base Update Test
'*
'************************************************************************
'*
' #1 tDeleteDatabaseWithKey
' #1 tCheckScrollbar
' #1 tDeleteDatabaseThroughMenu
' #1 tUnDockPinFadeInOut
' #1 tExplorer
' #1 tSearch
' #1 tSortAscending
' #1 tAutofilter
' #1 tDefaultFilter
' #1 tSortOrder
' #1 tRemoveFilter
' #1 tApplyFilter
' #1 tRefresh
' #1 tEdit
' #1 tSaveNewDataEntry
' #1 tUndo
' #1 tCut
' #1 tCopy
' #1 tPaste
' #1 tDataToText
' #1 tDataToFields
' #1 tFormLetter
' #1 tGroupBox
' #1 tListBox
' #1 tComboBox
' #1 tTableControl
'*
'\***********************************************************************************
sub base_02

   printlog "------------------ base_02.inc ---------------------"

   printlog "---------------------- Misc. ------------------------"

     call tDeleteDatabaseWithKey
     call tCheckScrollbar
     call tDeleteDatabaseThroughMenu
     call tUnDockPinFadeInOut
   
   printlog "------------  Objectbar Database Beamer ------------"

     call tExplorer
     'call tSearch
     call tSortAscending
     call tAutofilter
     call tDefaultFilter
     call tSortOrder
     call tRemoveFilter
     call tApplyFilter
     call tRefresh
     call tEdit
     call tSaveNewDataEntry

   printlog "------------------ Function bar --------------------"

     call tUndo
     call tCut
     call tCopy
     call tPaste
   
   printlog "------------  Objectbar Database Beamer ------------"
   
     call tDataToText
     call tDataToFields
     call tFormLetter

   printlog "---------------- Form Autopilots -------------------"
     call tGroupBox
     call tListBox
     call tComboBox
     call tTableControl

end sub

'-------------------------------------------------------------------------

testcase tDeleteDatabaseWithKey
 printlog "Deleting a database with <DEL>-key."
 Dim SourcesName as string
 Dim SourcesNameVerify as string
 Dim SourcesNameTwo as string
 Dim NewSourceText as string
 Dim IstStatusMsg as string
 Dim a as integer
 Dim i as integer
 Dim u as integer

  call hNewDocument
  ToolsDataSources
  Kontext "DataSourceAdministration"
   call Dialogtest (DataSourceAdministration)
   'Default should be one source (bibliography)!
   i = DatabaseSourceList.GetItemCount
   'if i > 2 then
   '  warnlog "There should be 1 (or 2 (MSC)) database source(s) in the list but there are " & i & " in the list!"
   'end if
   if i > 0 then
     for a = 1 to i
       SourcesName = DatabaseSourceList.GetItemText(a)
       printlog "Existing sources (" & a &"/" & i & "): " & SourcesName
     next a
    else
     warnlog "There are no data sources available! Bug!"
   end if
   NewDataSource.Click
  Kontext "TabGeneral"
   NewSourceText = SourceName.GetText
   sleep(1)
  Kontext "DataSourceAdministration"
   DatabaseSourceList.Typekeys "<TAB>" , 9 , true
   sleep(1)
   DatabaseSourceList.TypeKeys "<HOME>" , true
   for a = 1 to i+1
    SourcesNameVerify = DatabaseSourceList.GetItemText(a)
    if SourcesNameVerify = NewSourceText then
      Kontext "DataSourceAdministration"
       Apply.Click
       sleep(1)
       DataSourceAdministration.TypeKeys "<TAB>" , 3 , true
       DatabaseSourceList.TypeKeys "<DELETE>" , true
       sleep(1)
       Kontext "TabGeneral"
        IstStatusMsg = StatusMessage.Caption
        printlog "'" & IstStatusMsg & "'"
        if IstStatusMsg = "" then
          warnlog "Status message was empty if a database was deleted! Bug!"
        end if
       Kontext "DataSourceAdministration"
        Apply.Click
        u = DatabaseSourceList.GetItemCount
        if u <> i then
         warnlog "The database has not been deleted!"
        end if
        exit for
     else
      DatabaseSourceList.TypeKeys "<DOWN>" , true
    end if
   next a
  Kontext "DataSourceAdministration"
   DataSourceAdministration.Cancel
  call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tCheckScrollbar
 Dim CountOfEntries as integer
 Dim i as integer
  call hNewDocument
  ToolsDataSources
  Kontext "DataSourceAdministration"
  for i = 1 to 80
   if DatabaseSourceList.HasScrollbar = TRUE then
     if DatabaseSourceList.IsScrollbarEnabled = TRUE then
       CountOfEntries = DatabaseSourceList.GetItemCount
       printlog "- " & CountOfEntries & " database sources needed to get a scrollbar."
       i = 80
      else
       warnlog "Scrollbar is visible but not enabled?!?!"
     end if
    else
     NewDataSource.Click
   end if
  next i
  Kontext "DataSourceAdministration"
   DataSourceAdministration.Cancel
  call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tDeleteDatabaseThroughMenu
 printlog "Deleting a database through context menu."
 Dim SourcesName as string
 Dim SourcesNameVerify as string
 Dim SourcesNameTwo as string
 Dim NewSourceText as string
 Dim IstStatusMsg as string

 Dim a as integer
 Dim i as integer
 Dim u as integer
  call hNewDocument
  ToolsDataSources
  Kontext "DataSourceAdministration"
   call Dialogtest (DataSourceAdministration)
   'Default should be one source (bibliography)!
   i = DatabaseSourceList.GetItemCount
   'if i > 2 then
   '  warnlog "There should be 1 (or 2 (MSC)) database source(s) in the list but there are " & i & " in the list!"
   'end if
   if i > 0 then
     for a = 1 to i
       SourcesName = DatabaseSourceList.GetItemText(a)
       printlog "Existing sources (" & a &"/" & i & "): " & SourcesName
     next a
    else
     warnlog "There are no data sources available! Bug!"
   end if
   NewDataSource.Click
  Kontext "TabGeneral"
   NewSourceText = SourceName.GetText
   sleep(1)
  Kontext "DataSourceAdministration"
   DatabaseSourceList.Typekeys "<TAB>" , 9 , true
   sleep(1)
   DatabaseSourceList.TypeKeys "<HOME>" , true
   for a = 1 to i+1
    SourcesNameVerify = DatabaseSourceList.GetItemText(a)
    if SourcesNameVerify = NewSourceText then
      Kontext "DataSourceAdministration"
       Apply.Click
       sleep(1)
       DataSourceAdministration.TypeKeys "<TAB>" , 3 , true
       DatabaseSourceList.MouseDown (88,88)
       DatabaseSourceList.MouseUp (88,88)
       DatabaseSourceList.OpenContextMenu TRUE
       hMenuSelectNr (2)
       sleep(1)
       Kontext "TabGeneral"
        IstStatusMsg = StatusMessage.Caption
        printlog "'" & IstStatusMsg & "'"
        if IstStatusMsg = "" then
          warnlog "Status message was empty if a database was deleted! Bug!"
        end if
       Kontext "DataSourceAdministration"
        Apply.Click
        u = DatabaseSourceList.GetItemCount
        if u <> i then
         warnlog "The database has not been deleted!"
        end if
        exit for
     else
      DatabaseSourceList.TypeKeys "<DOWN>" , true
    end if
   next a
  Kontext "DataSourceAdministration"
   DataSourceAdministration.Cancel
  call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tUnDockPinFadeInOut
  call hNewDocument
  ViewCurrentDatabase
  sleep(4)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DocumentWriter"
       '/// pin the database beamer
       DocumentWriter.Pin ( TRUE , AlignTop )
      printlog "- pin the database beamer"
      '/// minimize the database beamer
      printlog "- minimize the database beamer"
       DocumentWriter.FadeOut ( AlignTop )
       sleep(2)
       '/// maximize the database beamer
      printlog "- maximize the database beamer"
       DocumentWriter.FadeIn ( AlignTop )
       sleep(2)
     else
      warnlog "'View current database' does not open the database beamer!"
    end if
  Kontext "DatabaseBeamer"
   if DatabaseBeamer.Exists(3) then ViewCurrentDatabase
  call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tGroupBox
 Dim j as integer
 for j = 1 to 4
   select case j
      case 1       : gApplication = "WRITER"
      case 2       : gApplication = "CALC"
      case 3       : gApplication = "GLOBALDOC"
      case 4       : gApplication = "HTMLDOKUMENT"
   end select

  printlog "- Formular toolbox: Group box element (" & gApplication & ")"
  call hNewDocument
  sleep(1)
  Kontext "WL_SW"
   Formular.TearOff
   Kontext "TB_Formularfunktionen"
	_FormularNavigator.Click
   sleep(2)
  Kontext "FormularNavigator"
   Liste.TypeKeys "<SPACE>" , true
   sleep(3)
   Liste.OpenContextmenu
   sleep(2)
   hMenuSelectNr (1)
   sleep(2)
   hMenuSelectNr (1)
   sleep(3)
   Liste.TypeKeys "<RETURN>" , true
   sleep(3)
   Liste.OpenContextmenu
   sleep(2)
   hMenuSelectNr (6)
   sleep(4)
  Kontext "ControlPropertiesDialog"
   ControlPropertiesControl.SetPage ControlPropertiesData
  Kontext "ControlPropertiesData"
   call Dialogtest(ControlPropertiesData)
   DataSource.Select(1)
   sleep(1)
   Content.Select(1)
   sleep(1)
  Kontext "ControlPropertiesDialog"
   ControlPropertiesDialog.Close
   sleep(3)
  Kontext "FormularNavigator"
   FormularNavigator.Close
   printlog "Closing the navigator!"
   sleep(4)
  Kontext "TB_Formularfunktionen"
   printlog "   - Form-Navigator"
   Groupbox.Click
   call hDrawingWithSelection ( 10, 30, 20, 35 )   
   sleep(10)
   call sAutopilot_Groupelement
   Kontext "Messagebox"
   if Messagebox.Exists(3) then
     warnlog Messagebox.Gettext
     Messagebox.Ok
    else
     sMenufunctions( "Groupbox" )
   end if
  Kontext "TB_Formularfunktionen"
   if TB_Formularfunktionen.Exists(3) then TB_Formularfunktionen.Close
   call hCloseDocument
 next j
 gApplication = "WRITER"
endcase

'-------------------------------------------------------------------------

testcase tListBox
 Dim j as integer
 for j = 1 to 4
   select case j
      case 1        : gApplication = "WRITER"
      case 2       : gApplication = "CALC"
      case 3       : gApplication = "GLOBALDOC"
      case 4       : gApplication = "HTMLDOKUMENT"
   end select

  printlog "- Formular toolbox: List box element (" & gApplication & ")"
  call hNewDocument
  sleep(1)
  Kontext "WL_SW"
   Formular.TearOff
  Kontext "TB_Formularfunktionen"
   Listbox.Click
   call hDrawingWithSelection ( 60, 40, 70, 55 )
   sleep(10)
   call sAutopilot_ListBox
   Kontext "Messagebox"
   if Messagebox.Exists(3) then
     warnlog Messagebox.Gettext
     Messagebox.Ok
    else
     sMenufunctions( "Listbox" )
   end if
  Kontext "TB_Formularfunktionen"
   if TB_Formularfunktionen.Exists(3) then TB_Formularfunktionen.Close
   call hCloseDocument
 next j
 gApplication = "WRITER"
endcase

'-------------------------------------------------------------------------

testcase tComboBox
 Dim j as integer
 for j = 1 to 4
   select case j
      case 1       : gApplication = "WRITER"
      case 2       : gApplication = "CALC"
      case 3       : gApplication = "GLOBALDOC"
      case 4       : gApplication = "HTMLDOKUMENT"
   end select

  printlog "- Formular toolbox: List box element (" & gApplication & ")"
  call hNewDocument
  sleep(1)
  Kontext "WL_SW"
   Formular.TearOff
  Kontext "TB_Formularfunktionen"
   Combobox.Click
   call hDrawingWithSelection ( 60, 40, 70, 55 )
   sleep(10)
   call sAutopilot_ComboBox
   Kontext "Messagebox"
   if Messagebox.Exists(3) then
     warnlog Messagebox.Gettext
     Messagebox.Ok
    else
     sMenufunctions( "Combobox" )
   end if
  Kontext "TB_Formularfunktionen"
   Exceptlog
   if TB_Formularfunktionen.Exists(3) then TB_Formularfunktionen.Close
   call hCloseDocument
 next j
 gApplication = "WRITER"
endcase

'-------------------------------------------------------------------------

testcase tTableControl
 Dim j as integer
 for j = 1 to 4
   select case j
      case 1        : gApplication = "WRITER"
      case 2       : gApplication = "CALC"
      case 3       : gApplication = "GLOBALDOC"
      case 4       : gApplication = "HTMLDOKUMENT"
   end select

  printlog "- Formular toolbox: List box element (" & gApplication & ")"
  call hNewDocument
  sleep(1)
  Kontext "WL_SW"
   Formular.TearOff   
  Kontext "TB_Formularfunktionen"  
   TabellenControl.Click
   call hDrawingWithSelection ( 60, 40, 70, 55 )
   sleep(10)
   call sAutopilot_TableElement
   Kontext "Messagebox"
   if Messagebox.Exists(3) then
     warnlog Messagebox.Gettext
     Messagebox.Ok
    else
     sMenufunctions( "TabellenControl" )
   end if
  Kontext "TB_Formularfunktionen"
   if TB_Formularfunktionen.Exists(3) then TB_Formularfunktionen.Close
   call hCloseDocument
 next j
 gApplication = "WRITER"
endcase

'-------------------------------------------------------------------------

testcase tExplorer
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
     Kontext "OB_DB_Beamer"
      Explorer.Click
      Kontext "DatabaseSelection"
       if DatabaseSelection.IsVisible then
         warnlog "The database explorer has not been hided!"
        else
         Kontext "OB_DB_Beamer"
          Explorer.Click
       end if
     else
      warnlog "Current database does not open the database beamer!"
    end if
  Kontext "OB_DB_Beamer"
   if OB_DB_Beamer.Exists(3) then ViewCurrentDatabase
  call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tSearch
 Dim ApplicationStarted as string
 Dim j as integer
 for j = 1 to 3
   select case j
      case 1       :  gApplication = "GLOBALDOKUMENT"
                       call hNewDocument
                      Kontext "DocumentMasterDoc"
                       DocumentMasterDoc.TypeKeys "<F5>" , true
                       ViewCurrentDatabaseWriter

      case 2       :  gApplication = "CALC"
                       call hNewDocument
                      Kontext "DocumentCalc"
                       ViewCurrentDatabaseCalc

      case 3        :  gApplication = "WRITER"
                       call hNewDocument
                      Kontext "DocumentWriter"
                       ViewCurrentDatabaseWriter

   end select
   sleep(4)
   printlog "- Objectbar: Search (" & gApplication & ")"
  Kontext "OB_DB_Beamer"
    if OB_DB_Beamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "OB_DB_Beamer"
          Search.Click
          sleep(3)
         Kontext "RecordSearch"
          call Dialogtest(RecordSearch)
          CloseBtn.Click
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
 next j
 gApplication = "WRITER"
endcase

'-------------------------------------------------------------------------

testcase tSortAscending
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "OB_DB_Beamer"
          SortAscending.Click
          sleep(10)
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tSortDescending
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "OB_DB_Beamer"
          SortDescending.Click
          sleep(3)
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tAutofilter
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "OB_DB_Beamer"
          Autofilter.Click
          sleep(3)
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tDefaultFilter
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "OB_DB_Beamer"
          DefaultFilter.Click
          sleep(3)
         Kontext "FilterDialog"
          call Dialogtest(FilterDialog)
          FilterDialog.Cancel
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tSortOrder
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "OB_DB_Beamer"
          SortOrder.Click
          sleep(3)
         Kontext "SortOrder"
          call Dialogtest(SortOrder)
          SortOrder.Cancel
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tRemoveFilter
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "OB_DB_Beamer"
          if RemoveFilter.IsEnabled then
           RemoveFilter.Click
          else
           Autofilter.Click
           sleep(2)
           RemoveFilter.Click
          end if
          sleep(3)
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tApplyFilter
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "OB_DB_Beamer"
          if ApplyFilter.IsEnabled then
           ApplyFilter.Click
          else
           Autofilter.Click
           sleep(2)
           ApplyFilter.Click
          end if
          sleep(3)
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tRefresh
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "OB_DB_Beamer"
          Refresh.Click
          sleep(3)
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tEdit
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "DatabaseSelection"
          DatabaseSelection.TypeKeys "<MOD1 SHIFT E>" , true
          sleep(2)
         Kontext "DatabaseTableView"
          DatabaseTableView.TypeKeys "Test" , TRUE
         Kontext "OB_DB_Beamer"
          if Edit.IsEnabled then
             Edit.Click
             sleep(2)
            Kontext "Messagebox"
             if Messagebox.Exists(3) then Messagebox.No
            Kontext "OB_DB_Beamer"
             Edit.Click
           else
            warnlog "'Edit' button not enabled!"
          end if
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tSaveNewDataEntry
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "DatabaseSelection"
          DatabaseSelection.TypeKeys "<MOD1 SHIFT E>" , true
          sleep(2)
         Kontext "DatabaseTableView"
          DatabaseTableView.TypeKeys "Test" , TRUE
         Kontext "OB_DB_Beamer"
          if SaveNewDataEntry.IsEnabled then
            printlog "Save a New Data Entry - button enabled"
           else
            warnlog "Data has been changed but 'Save a New Data Entry' button is disabled!"
          end if
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
        sleep(2)
       Kontext "Messagebox"
        if Messagebox.Exists(3) then Messagebox.No
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tUndo
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "DatabaseSelection"
          DatabaseSelection.TypeKeys "<TAB>" , true
          sleep(2)
         Kontext "DatabaseTableView"
          DatabaseTableView.TypeKeys "Test" , TRUE
         Kontext "OB_DB_Beamer"
          Undo.Click
          sleep(2)
          if SaveNewDataEntry.IsEnabled then warnlog "'Save a New Data Entry'-button is enabled after UNDO!"
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tCut
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "DatabaseSelection"
          DatabaseSelection.TypeKeys "<MOD1 SHIFT E>" , true
          sleep(2)
         Kontext "Funktionsleiste"
          Ausschneiden.Click
          sleep(2)
          Kontext "OB_DB_Beamer"
           if NOT SaveNewDataEntry.IsEnabled then warnlog "Save button is not enabled after CUT!"
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
       Kontext "Messagebox"
        if Messagebox.Exists(3) then Messagebox.No
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tCopy
 Dim ThereMustBeSomeText as string
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "DatabaseSelection"
          DatabaseSelection.TypeKeys "<MOD1 SHIFT E>" , true
          sleep(2)
         Kontext "Funktionsleiste"
          SetClipboard = ""
          Kopieren.Click
          ThereMustBeSomeText = GetClipboardText
          if ThereMustBeSomeText = "" then warnlog "Copy with 'copy' button to clipboard failed!"
          sleep(2)
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tPaste
  call hNewDocument
  ViewCurrentDatabase
  sleep(5)
  SetClipboard = "Test"
  sleep(1)
  Kontext "DatabaseBeamer"
    if not DatabaseBeamer.Exists(3) then
        warnlog "Current database does not open the database beamer!"
        call hCloseDocument
    end if
  Kontext "DatabaseSelection"
    if fFindTable("Bibliography","biblio") = TRUE then
      sleep(5)
      Kontext "DatabaseSelection"
        DatabaseSelection.TypeKeys "<TAB>" , true
        sleep(2)
      Kontext "Funktionsleiste"
        Einfuegen.Click
          sleep(2)
    else
      warnlog "Can't select the database 'biblio'!!"
    end if
  Kontext "OB_DB_Beamer"
    ViewCurrentDatabase
  Kontext "Messagebox"
    if Messagebox.Exists(3) then
       Messagebox.No
    else
      warnlog "The messagebox did not appear!"
      warnlog "May the 'paste' function failed!"
    end if     
  call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tDataToText
 Dim TabAnzahl as integer
 Dim EntryCount as integer
 Dim CountOfParaStyles as integer
  call hNewDocument
  ViewCurrentDatabase
  SetClipboard = "Test"
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "DatabaseSelection"
          DatabaseSelection.TypeKeys "<MOD1 SHIFT E>" , true
          sleep(2)
         Kontext "DatabaseTableView"
          DatabaseTableView.TypeKeys "<SHIFT DOWN>" , TRUE
          sleep(2)
          DatabaseTableView.TypeKeys "<SHIFT UP>" , TRUE
          sleep(2)
         Kontext "OB_DB_Beamer"
          DataToText.Click
          sleep(2)
          printlog "- Open the Insert Database Columns dialog"
         Kontext "InsertDataColumns"
          call Dialogtest(InsertDataColumns)
          printlog "- Table"
          if TableBtn.IsChecked = FALSE then
            warnlog "Why not 'Table' checked as default?"
            TableBtn.Check
            sleep(1)
          end if
          if TableColumns.IsVisible = FALSE then warnlog "Listbox with table columns not visible!"
          AllToButton.Click
          sleep(1)
          printlog "- Properties"
          Properties.Click
          sleep(3)
         Kontext "Active"
          if Active.Exists(3) then
             TabAnzahl = Active.GetPageCount
              if TabAnzahl <> 5  then warnlog "Number of tabpages is " & TabAnzahl & " instead of 5 !!!"
            Kontext
             Active.SetPage TabellenFormat
            Kontext "TabellenFormat"
             Call Dialogtest ( TabellenFormat )
            Kontext
             Active.SetPage TabTextflussTabelle
            Kontext "TabTextflussTabelle"
             Call Dialogtest ( TabTextflussTabelle )
            Kontext
             Active.SetPage TabSpaltenTabelle
            Kontext "TabSpaltenTabelle"
             Call Dialogtest ( TabSpaltenTabelle )
            Kontext
             Active.SetPage TabUmrandung
            Kontext "TabUmrandung"
            Call Dialogtest ( TabUmrandung )
            Kontext
             Active.SetPage TabHintergrund
            Kontext "TabHintergrund"
             Call Dialogtest ( TabHintergrund )
             TabHintergrund.Cancel
             sleep(2)
           else
            warnlog "'Table Format' dialog is not visible!"
          end if
         Kontext "InsertDataColumns"
          printlog "- AutoFormat"
          AutoFormat.Click
          sleep(2)
         Kontext "AutoFormatTabelle"
          if AutoFormatTabelle.Exists(3) then
            call Dialogtest(AutoFormatTabelle)
            EntryCount = Formatbox.GetItemCount
            if EntryCount > 2 then
               Formatbox.Select(3)
               Zusaetze.Open
               Umbenennen.Click
              Kontext "AutoformatHinzufuegenWriter"
               call Dialogtest(AutoformatHinzufuegenWriter)
               AutoformatHinzufuegenWriter.Cancel
              Kontext "AutoFormatTabelle"
               Zusaetze.Close
               AutoFormatTabelle.Cancel
             else
              warnlog "Only " & EntryCount & " table formats available?"
            end if
           else
            warnlog "'AutoFormat' dialog is not visible!"
          end if
         Kontext "InsertDataColumns"
          printlog "- Fields"
          FieldsBtn.Check
          if FieldsInList.IsVisible = FALSE then warnlog "Selcted 'Fields' area not visible!"
          CountOfParaStyles = ParagraphStyle.GetItemCount
          if (iSprache = 86 OR iSprache = 88 ) then  
            if CountOfParaStyles <> 122 then warnlog "There are " & CountOfParaStyles & " paragraph styles instead of 122 available!"
          else
            if CountOfParaStyles <> 123 then warnlog "There are " & CountOfParaStyles & " paragraph styles instead of 123 available!(#114548#)"
          endif
          printlog "- Text"
          TextBtn.Check
          if FieldsInList.IsVisible = FALSE then warnlog "Selcted 'Fields' area not visible!"
          CountOfParaStyles = ParagraphStyle.GetItemCount
          if (iSprache = 86 OR iSprache = 88 ) then
            if CountOfParaStyles <> 122 then warnlog "There are " & CountOfParaStyles & " paragraph styles instead of 122 available!"
          else
            if CountOfParaStyles <> 123 then warnlog "There are " & CountOfParaStyles & " paragraph styles instead of 123 available!(#114548#)"
          endif
          InsertDataColumns.Cancel
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
       Kontext "Messagebox"
        if Messagebox.Exists(3) then
          warnlog Messagebox.GetText
          Messagebox.No
        end if
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tDataToFields
  call hNewDocument
  ViewCurrentDatabase
  SetClipboard = "Test"
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "DatabaseSelection"
          DatabaseSelection.TypeKeys "<MOD1 SHIFT E>" , true
          sleep(2)
         Kontext "DatabaseTableView"
          DatabaseTableView.TypeKeys "<SHIFT DOWN>" , TRUE
          sleep(2)
          DatabaseTableView.TypeKeys "<SHIFT UP>" , TRUE
          sleep(2)
         Kontext "OB_DB_Beamer"
          DataToFields.Click
          sleep(2)
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
       Kontext "Messagebox"
        if Messagebox.Exists(3) then
          printlog "BugId: #93997"
          Messagebox.No
        end if
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tFormLetter
 Dim CountOfEntries as integer
  call hNewDocument
  ViewCurrentDatabase
  SetClipboard = "Test"
  sleep(5)
  Kontext "DatabaseBeamer"
    if DatabaseBeamer.Exists(3) then
      Kontext "DatabaseSelection"
       if fFindTable("Bibliography","biblio") = TRUE then
          sleep(5)
         Kontext "DatabaseSelection"
          DatabaseSelection.TypeKeys "<MOD1 SHIFT E>" , true
          sleep(2)
         Kontext "DatabaseTableView"
          DatabaseTableView.TypeKeys "<SHIFT DOWN>" , TRUE
          sleep(2)
          DatabaseTableView.TypeKeys "<SHIFT UP>" , TRUE
          sleep(2)
         Kontext "OB_DB_Beamer"
          FormLetter.Click
          sleep(2)
         Kontext "Serienbrief"
          if Serienbrief.Exists(3) then
           call Dialogtest(Serienbrief)
           if DatensaetzeMarkiert.IsChecked = FALSE then warnlog "There has been selected one data record and 'Selected records' is not checked?!"
           if Drucker.IsChecked = FALSE then warnlog " The default output should be 'printer' but it isn't!"
           Kontext "Serienbrief"
           printlog "- File"
            AlsDatei.Check
            sleep(1)
            if DateiButton.IsEnabled then
               DateiButton.Click
               sleep(3)
              Kontext "OeffnenDlg"
               if OeffnenDlg.Exists(3) then
                 call Dialogtest(OeffnenDlg)
                 OeffnenDlg.Cancel
                 sleep(1)
                else
                 warnlog "'File Open' dialog not visible!"
               end if
             else
              warnlog "Button to open the 'File Open' dialog isn't visible!"
            end if
           Kontext "Serienbrief"
            Serienbrief.Cancel
          end if
        else
          warnlog "Can't select the database 'biblio'!!"
       end if
       Kontext "OB_DB_Beamer"
        ViewCurrentDatabase
       Kontext "Messagebox"
        if Messagebox.Exists(3) then
          warnlog Messagebox.GetText
          Messagebox.No
        end if
     else
      warnlog "Current database does not open the database beamer!"
    end if
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

