'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: sxd_03.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:53:44 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**********************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : XML Draw Include File
'*
'\***********************************************************************************
   Dim Isliste(250) as string
   Dim OutputPath as string

sub sxd_03

   printlog "------------------- sxd_03.inc ---------------------"

   Call ExitRestartTheOffice
   call t18126
   call t18127_18128
   call t18129
   call t18130_18131
   call t18132
   call t18133_18134
   call t18135
   call t18136
   call t18137
   call t18138

end sub

'-------------------------------------------------------------------------

testcase t18126
  printlog "+- Draw: 18126.sda"
  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\update\input\draw\18126.sda"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\draw\update\18126.sxd") , gDrawFilter) = TRUE then
    call hCloseDocument
    sleep(2)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\draw\update\18126.sxd") , gOfficePath & ConvertPath("user\work\xml\draw\update\18126\") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18126\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18126\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18126\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\draw\update\18126.sxd")
      call hCloseDocument
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase t18127_18128
  printlog "+- Draw: 18127-18128.sda"
  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\update\input\draw\18127-18128.sda"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\draw\update\18127-18128.sxd") , gDrawFilter) = TRUE then
    call hCloseDocument
    sleep(2)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\draw\update\18127-18128.sxd") , gOfficePath & ConvertPath("user\work\xml\draw\update\18127-18128\") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18127-18128\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18127-18128\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18127-18128\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\draw\update\18127-18128.sxd")
      call hCloseDocument
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase t18129
  printlog "+- Draw: 18129.sda"
  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\update\input\draw\18129.sda"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\draw\update\18129.sxd") , gDrawFilter) = TRUE then
    call hCloseDocument
    sleep(2)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\draw\update\18129.sxd") , gOfficePath & ConvertPath("user\work\xml\draw\update\18129\") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18129\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18129\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18129\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\draw\update\18129.sxd")
      call hCloseDocument
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase t18130_18131
  printlog "+- Draw: 18130-18131.sda"
  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\update\input\draw\18130-18131.sda"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\draw\update\18130-18131.sxd") , gDrawFilter) = TRUE then
    call hCloseDocument
    sleep(2)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\draw\update\18130-18131.sxd") , gOfficePath & ConvertPath("user\work\xml\draw\update\18130-18131\") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18130-18131\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18130-18131\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18130-18131\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\draw\update\18130-18131.sxd")
      call hCloseDocument
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase t18132
  printlog "+- Draw: 18132.sda"
  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\update\input\draw\18132.sda"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\draw\update\18132.sxd") , gDrawFilter) = TRUE then
    call hCloseDocument
    sleep(2)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\draw\update\18132.sxd") , gOfficePath & ConvertPath("user\work\xml\draw\update\18132\") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18132\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18132\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18132\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\draw\update\18132.sxd")
      call hCloseDocument
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase t18133_18134
  printlog "+- Draw: 18133-18134.sda"
  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\update\input\draw\18133-18134.sda"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\draw\update\18133-18134.sxd") , gDrawFilter) = TRUE then
    call hCloseDocument
    sleep(2)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\draw\update\18133-18134.sxd") , gOfficePath & ConvertPath("user\work\xml\draw\update\18133-18134\") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18133-18134\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18133-18134\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18133-18134\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\draw\update\18133-18134.sxd")
      call hCloseDocument
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase t18135
  printlog "+- Draw: 18135.sda"
  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\update\input\draw\18135.sda"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\draw\update\18135.sxd") , gDrawFilter) = TRUE then
    call hCloseDocument
    sleep(2)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\draw\update\18135.sxd") , gOfficePath & ConvertPath("user\work\xml\draw\update\18135\") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18135\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18135\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18135\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\draw\update\18135.sxd")
      call hCloseDocument
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase t18136
  printlog "+- Draw: 18136.sda"
  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\update\input\draw\18136.sda"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\draw\update\18136.sxd") , gDrawFilter) = TRUE then
    call hCloseDocument
    sleep(2)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\draw\update\18136.sxd") , gOfficePath & ConvertPath("user\work\xml\draw\update\18136\") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18136\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18136\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18136\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\draw\update\18136.sxd")
      call hCloseDocument
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase t18137
  printlog "+- Draw: 18137.sda"
  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\update\input\draw\18137.sda"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\draw\update\18137.sxd") , gDrawFilter) = TRUE then
    call hCloseDocument
    sleep(2)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\draw\update\18137.sxd") , gOfficePath & ConvertPath("user\work\xml\draw\update\18137\") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18137\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18137\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18137\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\draw\update\18137.sxd")
      call hCloseDocument
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

testcase t18138
  printlog "+- Draw: 18138.sda"
  call hDateiOeffnen (gTesttoolPath & ConvertPath("xml\update\input\draw\18138.sda"))
  if hSpeichernUnterMitFilterKill (gOfficePath & ConvertPath("user\work\xml\draw\update\18138.sxd") , gDrawFilter) = TRUE then
    call hCloseDocument
    sleep(2)
    UnpackStorage( gOfficePath & ConvertPath("user\work\xml\draw\update\18138.sxd") , gOfficePath & ConvertPath("user\work\xml\draw\update\18138\") )
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18138\styles.xml")) = FALSE then
      warnlog "XML-file 'styles.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18138\meta.xml")) = FALSE then
      warnlog "XML-file 'meta.xml' not well formed!"
    end if
    if XMLWellformed (gOfficePath & ConvertPath("user\work\xml\draw\update\18138\content.xml")) = FALSE then
      warnlog "XML-file 'content.xml' not well formed!"
     else
      call hDateiOeffnen (gOfficePath & ConvertPath("user\work\xml\draw\update\18138.sxd")
      call hCloseDocument
    end if
   else
    warnlog "It was not possible to save the document as XML!"
  end if
endcase

'-------------------------------------------------------------------------

